<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
            <el-form-item label="关联的计划" prop="upgradeId">
                <el-input v-model="queryParams.upgradeId" placeholder="请输入关联的计划" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="更新人员" prop="operator">
                <el-input v-model="queryParams.operator" placeholder="请输入更新人员" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="版本" prop="version">
                <el-input v-model="queryParams.version" placeholder="请输入版本" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="Plus" @click="handleAdd"
                    v-hasPermi="['pms:records:add']">新增</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
                    v-hasPermi="['pms:records:edit']">修改</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
                    v-hasPermi="['pms:records:remove']">删除</el-button>
            </el-col>
            <!-- <el-col :span="1.5">
                <el-button type="warning" plain icon="Download" @click="handleExport"
                    v-hasPermi="['pms:records:export']">导出</el-button>
            </el-col> -->
            <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="recordsList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <el-table-column type="index" :label="$t('common.序号')" width="60" align="center" />
            <el-table-column label="关联的计划" align="center" prop="upgradeId" >
                <template #default="scope">
                    {{ upgradeList.find(item => item.id === scope.row.upgradeId)?.upgradePlan }}
                </template>
            </el-table-column>
            <el-table-column label="更新内容" align="center" prop="updateContent" />
            <el-table-column label="更新人员" align="center" prop="operator" />
            <el-table-column label="版本" align="center" prop="version" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template #default="scope">
                    <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                        v-hasPermi="['pms:records:edit']">修改</el-button>
                    <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                        v-hasPermi="['pms:records:remove']">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
            v-model:limit="queryParams.pageSize" @pagination="getList" />

        <!-- 添加或修改设备软硬件升级记录对话框 -->
        <el-dialog :title="title" v-model="open" width="800px" append-to-body>
            <el-form ref="recordsRef" :model="form" :rules="rules" label-width="120px">
                <el-form-item label="关联的计划" prop="upgradeId">
                    <el-select v-model="form.upgradeId" filterable placeholder="请选择关联的计划" style="width: 240px">
                        <el-option v-for="item in upgradeList" :key="item.id" :label="item.upgradePlan" :value="item.id" />
                    </el-select>
                </el-form-item>
                <el-form-item label="更新内容">
                    <el-input v-model="form.updateContent" style="width: 6000px" :rows="5" type="textarea"
                        placeholder="请输入更新内容" />
                </el-form-item>
                <el-form-item label="更新人员" prop="operator">
                    <el-input v-model="form.operator" placeholder="请输入更新人员" />
                </el-form-item>
                <el-form-item label="版本" prop="version">
                    <el-input v-model="form.version" placeholder="请输入版本" />
                </el-form-item>
            </el-form>
            <template #footer>
                <div class="dialog-footer">
                    <el-button type="primary" @click="submitForm">确 定</el-button>
                    <el-button @click="cancel">取 消</el-button>
                </div>
            </template>
        </el-dialog>
    </div>
</template>

<script setup name="Records">
import { listRecords, getRecords, delRecords, addRecords, updateRecords } from "@/api/pms/updateRecord";
import { listUpgrade } from "@/api/pms/upgrade";
import Editor from "@/components/Editor";

const { proxy } = getCurrentInstance();

const recordsList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
    form: {},
    queryParams: {
        pageNum: 1,
        pageSize: 10,
        upgradeId: null,
        updateContent: null,
        operator: null,
        version: null
    },
    rules: {
    }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备软硬件升级记录列表 */
function getList() {
    loading.value = true;
    listRecords(queryParams.value).then(response => {
        recordsList.value = response.rows;
        total.value = response.total;
        loading.value = false;
    });
}

let upgradeList = ref([]);
/** 查询设备软硬件升级计划列表 */
function getUpgradeList() {
    loading.value = true;
    let query = {
        pageNum: 1,
        pageSize: 1000,
        flag: 1
    }
    listUpgrade(query).then(response => {
        upgradeList.value = response.rows;
    });
}

// 取消按钮
function cancel() {
    open.value = false;
    reset();
}

// 表单重置
function reset() {
    form.value = {
        id: null,
        upgradeId: null,
        updateContent: null,
        updateTime: null,
        operator: null,
        version: null
    };
    proxy.resetForm("recordsRef");
}

/** 搜索按钮操作 */
function handleQuery() {
    queryParams.value.pageNum = 1;
    getList();
}

/** 重置按钮操作 */
function resetQuery() {
    proxy.resetForm("queryRef");
    handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
    reset();
    open.value = true;
    title.value = "添加设备软硬件升级记录";
}

/** 修改按钮操作 */
function handleUpdate(row) {
    reset();
    const _id = row.id || ids.value
    getRecords(_id).then(response => {
        form.value = response.data;
        open.value = true;
        title.value = "修改设备软硬件升级记录";
    });
}

/** 提交按钮 */
function submitForm() {
    proxy.$refs["recordsRef"].validate(valid => {
        if (valid) {
            if (form.value.id != null) {
                updateRecords(form.value).then(response => {
                    proxy.$modal.msgSuccess("修改成功");
                    open.value = false;
                    getList();
                });
            } else {
                addRecords(form.value).then(response => {
                    proxy.$modal.msgSuccess("新增成功");
                    open.value = false;
                    getList();
                });
            }
        }
    });
}

/** 删除按钮操作 */
function handleDelete(row) {
    const _ids = row.id || ids.value;
    proxy.$modal.confirm('是否确认删除设备软硬件升级记录编号为"' + _ids + '"的数据项？').then(function () {
        return delRecords(_ids);
    }).then(() => {
        getList();
        proxy.$modal.msgSuccess("删除成功");
    }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
    proxy.download('pms/records/export', {
        ...queryParams.value
    }, `records_${new Date().getTime()}.xlsx`)
}

getList();
getUpgradeList();
</script>